//
//  ViewController.m
//  sample
//
//  Created by Jambunathan, Ramkumar on 5/22/14.
//  Copyright (c) 2014 ___FULLUSERNAME___. All rights reserved.
//

#import "ViewController.h"

//We are moving View height 50px but merchant have to handle this according to his requirement
#define kOFFSET_FOR_KEYBOARD 50

@interface ViewController ()

@property (weak, nonatomic) IBOutlet VisaExpressCheckoutView *expressView;
@property (weak, nonatomic) IBOutlet UIImageView *cardArt;
@property (strong, nonatomic) VisaCheckout *visaCheckout;
@property (strong, nonatomic) IBOutlet VisaCheckoutButton *vxoButton;
@property (weak, nonatomic) IBOutlet UIView *exoHostView;
@property (weak, nonatomic) IBOutlet UIView *customHostView;
@property (weak, nonatomic) IBOutlet UIView *regularVCOHostView;
@property (weak, nonatomic) IBOutlet UIScrollView *scrollView;


@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    [self doTDProfiling];//trust defender check
    
	// Do any additional setup after loading the view, typically from a nib.
        self.expressView.hidden = YES;
    self.visaCheckout = [[VisaCheckout alloc]init];
    UITapGestureRecognizer *gesture = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(invokeVISASDKDirectly)];
    [self.cardArt addGestureRecognizer:gesture];
     [self addNotificationtosetViews];
}

-(void)viewDidAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    [self.cardArt setImage:[self.visaCheckout fetchCardArtImage]];
}
- (IBAction)valueChanged:(id)sender {
    
    NSInteger selectedIndex = [sender selectedSegmentIndex];
    
    NSString *type = [sender titleForSegmentAtIndex:selectedIndex];
    if([type isEqualToString:@"EXO"] && selectedIndex == 0)
    {
        [self.scrollView bringSubviewToFront:self.exoHostView];
    }
    else if([type isEqualToString:@"Custom" ] && selectedIndex == 1)
    {
        [self.scrollView bringSubviewToFront:self.customHostView];
    }
    else if (selectedIndex == 2)
    {
        [self.scrollView bringSubviewToFront:self.regularVCOHostView];
    }
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - VISA checkout library delegates

- (VisaServer)visaServer {
    return kVisaSandboxServer;
}


//2.6 SDK Interface
- (VisaPaymentInfo *)paymentInfo {
    
    VisaPaymentInfo *paymentInfo = [[VisaPaymentInfo alloc] init];
    
    [paymentInfo setAmount:[NSDecimalNumber decimalNumberWithString:@"12"]];
    [paymentInfo setCurrency:VCurrencyCodeUS];
    paymentInfo.merchantRequestId = @"a001";
    paymentInfo.subtotal = [NSDecimalNumber decimalNumberWithString:@"0"];
    paymentInfo.shippingHandlingCharges = [NSDecimalNumber decimalNumberWithString:@"0"];
    paymentInfo.tax = [NSDecimalNumber decimalNumberWithString:@"0"];
    paymentInfo.discount = [NSDecimalNumber decimalNumberWithString:@"0"];
    paymentInfo.giftWrapCharges = [NSDecimalNumber decimalNumberWithString:@"0"];
    paymentInfo.miscCharges = [NSDecimalNumber decimalNumberWithString:@"0"];
    paymentInfo.paymentDescription = @"sample transcation";
    paymentInfo.orderId = @"111";
    paymentInfo.promoCode = @"freeCheckout";
    paymentInfo.isShippingAddressRequired = YES;
    paymentInfo.datalevel = @"SUMMARY";
    
    // Pass merchant information
    VisaMerchantInfo *merchantInfo = [[VisaMerchantInfo alloc] init];
    merchantInfo.merchantAPIKey = @"LXFQZOKJIXXFYO20OMI313Hal2ScbAZYETLKqaXZpHFqZ8bDw";
    merchantInfo.userReviewAction = kVisaUserReviewActionContinue;
    merchantInfo.displayName = @"My Merchant Name";
    merchantInfo.externalProfileId = @"defaultprofile";
    merchantInfo.merchantLogoAssetName = @"mercLogo";
    merchantInfo.canadianDebitCardSupport = VAcceptCanadianDebitCard;
    merchantInfo.preferredLocale = VLocale_enUS;

    paymentInfo.merchantInfo = merchantInfo;
    
    //set up 3DS
    VisaThreeDSSetUp *threeDSSetUp = [VisaThreeDSSetUp new];
    threeDSSetUp.threeDSActive = VisaActivate3DS;
    paymentInfo.threeDSSetUp = threeDSSetUp;
    
    NSMutableArray *cardBrandArray = [[NSMutableArray alloc] initWithObjects:@"Visa", @"MasterCard", @"AMEX", @"Discover", nil];
    
    paymentInfo.acceptedPaymentTypesAndBrands = cardBrandArray;
    
    //set accepted countries for shipping
    NSMutableArray *acceptedShippingCountryList = [[NSMutableArray alloc] initWithObjects:@"Ca", @"us", @"AU" , nil];
    paymentInfo.acceptedShippingCountries = acceptedShippingCountryList;
    
    //set accepted countries for billing
    NSMutableArray *acceptedBillingCountryList = [[NSMutableArray alloc] initWithObjects:@"Ca", @"us", @"AU" , nil];
    paymentInfo.acceptedBillingCountries = acceptedBillingCountryList;
    
    return paymentInfo;
}
- (void)checkoutSuccessWithSummary:(VisaPaymentSummary*)paymentSummary {
    NSLog(@"success");
    
    NSString *successResponse = [NSString stringWithFormat:@"callID: %@\r lastFourDigits: %@\r cardBrand: %@\r cardType: %@\r countryCode: %@\r postalCode: %@\r encKey: %@\r encPaymentData: %@",paymentSummary.callId, 
                                 paymentSummary.lastFourDigits, paymentSummary.cardBrand, paymentSummary.cardType, paymentSummary.countryCode, paymentSummary.postalCode, paymentSummary.encKey, paymentSummary.encPaymentData];
    UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Payment successful!" message:successResponse delegate:nil cancelButtonTitle:@"OK" otherButtonTitles: nil];
    [alertView show];
}

- (void)checkoutFailedWithError:(NSError*)error{
    UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:nil message:[error localizedDescription] delegate:nil cancelButtonTitle:@"OK" otherButtonTitles: nil];
    [alertView show];
    NSLog(@"Error - %@", [error description]);
}

- (void)checkoutCancelled {
    NSLog(@"Cancelled");
}

-(NSString *)buttonColor
{
    return VisaCheckoutButtonColorNeutral;
}

- (void)invokeVISASDKDirectly {
    
    [self.visaCheckout invokeVisaCheckout:^(NSError *error) {
        
        if (error) {
            NSLog(@"Error Details..%@", [error localizedDescription]);
        }
        
    } withOptions:nil withDelegate:self];
}
-(void) addNotificationtosetViews
{
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(keyboardWillShow:)
                                                 name:UIKeyboardWillShowNotification
                                               object:nil];
    
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(keyboardWillHide:)
                                                 name:UIKeyboardWillHideNotification
                                               object:nil];
    
}

-(void)keyboardWillShow:(NSNotification *)notification {
    // Animate the current view out of the way
    
    if (self.view.frame.origin.y >= 0)
    {
        [self setViewMovedUp:YES];
    }
    else if(self.view.frame.origin.y < 0)
    {
        [self setViewMovedUp:NO];
    }
}

-(void)keyboardWillHide:(NSNotification *)notification {
    
    if (self.view.frame.origin.y >= 0)
    {
        [self setViewMovedUp:YES];
    }
    else if (self.view.frame.origin.y < 0)
    {
        [self setViewMovedUp:NO];
    }
}

//method to move the view up/down whenever the keyboard is shown/dismissed
-(void)setViewMovedUp:(BOOL)movedUp
{
    [UIView beginAnimations:nil context:NULL];
    [UIView setAnimationDuration:0.3]; // if you want to slide up the view
    
    CGRect rect = self.view.frame;
    if (movedUp)
    {
        // 1. move the view's origin up so that the text field that will be hidden come above the keyboard
        // 2. increase the size of the view so that the area behind the keyboard is covered up.
        rect.origin.y -= kOFFSET_FOR_KEYBOARD;
        rect.size.height += kOFFSET_FOR_KEYBOARD;
    }
    else
    {
        // revert back to the normal state.
        rect.origin.y += kOFFSET_FOR_KEYBOARD;
        rect.size.height -= kOFFSET_FOR_KEYBOARD;
    }
    self.view.frame = rect;
    
    [UIView commitAnimations];
}

#pragma mark - TD profiling

- (void)doTDProfiling {
    //trust defender co-existant check
    /*NSString *orgID;
     orgID = @"ay3xz4ma";
     
     [[[TrustDefenderMobile alloc] initWithConfig:@{TDMOrgID:orgID,
     TDMDelegate:self,
     TDMTimeout:@10,
     TDMLocationServices:@YES,
     TDMDesiredLocationAccuracy: @(kCLLocationAccuracyThreeKilometers)
     }] doProfileRequestWithCallback:^(NSDictionary *result) {
     NSLog(@"%@", result);
     
     }];*/
    
}

@end
